//Appname:
//SimpleCSGOMap

#include <dbi>
#include <sourcemod> 
#include <cstrike>
#include <clientprefs>
#include <sdktools>
#include <multicolors>
#include <smlib>

#define PLUGIN_VERSION "0.0.0"

//Global Variables, do NOT touch.
bool ready = false;
Handle dbc;
char errorc[255];
//new String:query[1000];
const int maxPlayers = 14;
char asyncQuery[1000]; //main storage buffer
int queriesStored = 0;
int dbLocked = 0;
int alive[maxPlayers]; //clients in the game
int active[maxPlayers]; //if a slot is empty only update it slowly so we dont waste queries.

char asyncQuery1[1000];//holders for threaded queries
char asyncQuery2[1000];
char asyncQuery3[1000];
char asyncQuery4[1000];
char asyncQuery5[1000];
char asyncQuery6[1000];
char asyncQuery7[1000];
char asyncQuery8[1000];
char asyncQuery9[1000];
char asyncQuery10[1000];
char asyncQuery11[1000];
char asyncQuery12[1000];
char asyncQuery13[1000];
char asyncQuery14[1000];


	

//editable defines
int printToServer = 0;

//begin
public Plugin:myinfo =
{
	name = "SimpleCSGOMap",
	author = "Puppetmaster",
	description = "SimpleCSGOMap Addon",
	version = PLUGIN_VERSION,
	url = "http://gamingzone.ddns.net/"
};


//called at start of plugin, sets everything up.
public OnPluginStart()
{
	newDB();
	ready = dbWorks(); //check if the database is set up. This does not ever function if sourcemod does not have mysql set up
	if(!ready){
		newDB(); //create a new table in the database if its not there
		ready = dbWorks(); //check again
	}
	//if the database doesnt work at all just disable the plugin
	 //try to clean the DB
	if(ready){
		PrintToServer("SimpleCSGOMap loaded. Database appears to be working");
		//dbc = SQL_DefConnect(errorc, sizeof(errorc)); //open the connection that will be used for the rest of the time
		dbc = SQL_Connect("render", false, errorc, sizeof(errorc)); //open the connection that will be used for the rest of the time
	}
	else{
		PrintToServer("Database Failure. Please make sure your MySQL database is correctly set up. If you believe it is please check the databases.cfg file, check the permissions and check the port."); //inform the user that its broken
	}
	for(int x =0;x<maxPlayers; x++){
		active[x] = 0; //fill with data
		alive[x] = 0;
	}
}

public OnMapStart ()
{
	//add some event which calls the update
	if(ready) CreateTimer(2.8, Timer_Update, _, TIMER_REPEAT); //update every 6 seconds if the db works
}

public bool dbWorks()
{
	//should return 1
	int isWorking = 0;
	new String:error2[255]
	new Handle:db = SQL_DefConnect(error2, sizeof(error2))
	if (db == INVALID_HANDLE)
	{
		if(printToServer == 1) PrintToServer("Could not connect: %s", error2)
	}
	else
	{
		new Handle:query = SQL_Query(db, "SELECT count(*) FROM information_schema.tables WHERE table_name = 'steam'")
		if (query == INVALID_HANDLE)
		{
			new String:error[255]
			SQL_GetError(db, error, sizeof(error))
			if(printToServer == 1) PrintToServer("Failed to query (error: %s)", error)
		} else {

			new String:name[65]
			while (SQL_FetchRow(query))
			{
				SQL_FetchString(query, 0, name, sizeof(name))
				if(printToServer == 1) PrintToServer("Steamid \"%s\" was found.", name)
				isWorking = StringToInt(name);
			}
		}
		CloseHandle(query)
		
	}
	CloseHandle(db)
	if(isWorking > 0) return true;
	else return false;	
}

public void newDB()
{
	new String:error2[255]
	new Handle:db = SQL_DefConnect(error2, sizeof(error2))
	PrintToServer("Adding database tables");
	if (!SQL_FastQuery(db, "CREATE TABLE `steamMap` (`client` char(65) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '', `team` INT DEFAULT NULL, `name` char(65) DEFAULT NULL, `location` char(65) DEFAULT NULL, `direction` char(65) DEFAULT NULL, `status` INT DEFAULT NULL, PRIMARY KEY (`client`)) ENGINE=InnoDB DEFAULT CHARSET=latin1"))
	{
		new String:error[255]
		SQL_GetError(db, error, sizeof(error))
		if(printToServer == 1) PrintToServer("Failed to query (error: %s)", error)
	}
	CloseHandle(db)
	return;
}


//queries

public queryCallback(Handle:owner, Handle:HQuery, const String:error[], any:client)
{
	CloseHandle(HQuery); //make sure the handle is closed before we allow anything to happen
	//printtoserver("client %d has updated", client);
	active[client-1] = 0;
	queriesStored--; //decrement now that we know its executed
	dbLocked = 0; //unlock db after everything is done
}

public Action:Timer_Update(Handle:timer)
{
	if(queriesStored > 0 || dbLocked > 0) {
		//PrintToServer("%s %d:%d", "Database is running very slow, missed this entire update. Trying again in 3 seconds:", queriesStored, dbLocked);
		return; //something should still be processing, data is locked until its next loop.
	}
	new maxclients = maxPlayers;//GetMaxClients()
	queriesStored = 0;
	float angles[3];
	float positions[3];
	decl String:name1[64];
	int live;
	//format the update queries
	for(new i=1; i <= maxclients; i++)
	{
		queriesStored++;
		if(IsClientInGame(i)) 
		{
			//Update the query
			asyncQuery = "";
			live = 0;
			if(IsPlayerAlive(i)) live = 1;
			GetClientEyeAngles(i, angles);
			GetClientAbsOrigin(i, positions);
			GetClientName(i, name1, sizeof(name1));
			//client team name location direction status
			
			//"INSERT INTO steamMap (client, team, name, location, direction, status) VALUES(1, "A", 19) ON DUPLICATE KEY UPDATE name=VALUES(name), age=VALUES(age)"
			Format(asyncQuery, sizeof(asyncQuery), "INSERT INTO steamMap (client, team, name, location, direction, status) VALUES(%d, %d, '\%s\', '\%f:%f:%f\', '\%f:%f:%f\', %d) ON DUPLICATE KEY UPDATE team=%d, name='\%s\', location='\%f:%f:%f\', direction='\%f:%f:%f\', status=%d; ", i, GetClientTeam(i), name1, positions[0], positions[1], positions[2], angles[0], angles[1], angles[2], live, GetClientTeam(i), name1, positions[0], positions[1], positions[2], angles[0], angles[1], angles[2], live);
			switch(i)
			{
				case 1:
				{
					Format(asyncQuery1, sizeof(asyncQuery1), "%s", asyncQuery);
					alive[0]++;
				}
				case 2:
				{
					Format(asyncQuery2, sizeof(asyncQuery2), "%s", asyncQuery);
					alive[1]++;
				}
				case 3:
				{
					Format(asyncQuery3, sizeof(asyncQuery3), "%s", asyncQuery);
					alive[2]++;
				}
				case 4:
				{
					Format(asyncQuery4, sizeof(asyncQuery4), "%s", asyncQuery);
					alive[3]++;
				}
				case 5:
				{
					Format(asyncQuery5, sizeof(asyncQuery5), "%s", asyncQuery);
					alive[4]++;
				}
				case 6:
				{
					Format(asyncQuery6, sizeof(asyncQuery6), "%s", asyncQuery);
					alive[5]++;
				}
				case 7:
				{
					Format(asyncQuery7, sizeof(asyncQuery7), "%s", asyncQuery);
					alive[6]++;
				}
				case 8:
				{
					Format(asyncQuery8, sizeof(asyncQuery8), "%s", asyncQuery);
					alive[7]++;
				}
				case 9:
				{
					Format(asyncQuery9, sizeof(asyncQuery9), "%s", asyncQuery);
					alive[8]++;
				}
				case 10:
				{
					Format(asyncQuery10, sizeof(asyncQuery10), "%s", asyncQuery);
					alive[9]++;
				}
				case 11:
				{
					Format(asyncQuery11, sizeof(asyncQuery11), "%s", asyncQuery);
					alive[10]++;
				}
				case 12:
				{
					Format(asyncQuery12, sizeof(asyncQuery12), "%s", asyncQuery);
					alive[11]++;
				}
				case 13:
				{
					Format(asyncQuery13, sizeof(asyncQuery13), "%s", asyncQuery);
					alive[12]++;
				}
				case 14:
				{
					Format(asyncQuery14, sizeof(asyncQuery14), "%s", asyncQuery);
					alive[13]++;
				}
				default:
				{
					PrintToServer("%s:%d", "A major error has occured", i);
				}
			}
			
			//queryNum++;
		}
		else{ //set their status to 0 
			//Update the query
			Format(asyncQuery, sizeof(asyncQuery), "INSERT INTO steamMap (client, team, name, location, direction, status) VALUES(%d, %d, '\%s\', '\%f:%f:%f\', '\%f:%f:%f\', %d) ON DUPLICATE KEY UPDATE team=%d, name='\%s\', location='\%f:%f:%f\', direction='\%f:%f:%f\', status=%d; ", i, 0, "none", 0, 0, 0, 0, 0, 0, 0, 0, "none", 0, 0, 0, 0, 0, 0, 0);
			switch(i)
			{
				case 1:
				{
					Format(asyncQuery1, sizeof(asyncQuery1), "%s", asyncQuery);
					active[0]++;
				}
				case 2:
				{
					Format(asyncQuery2, sizeof(asyncQuery2), "%s", asyncQuery);
					active[1]++;
				}
				case 3:
				{
					Format(asyncQuery3, sizeof(asyncQuery3), "%s", asyncQuery);
					active[2]++;
				}
				case 4:
				{
					Format(asyncQuery4, sizeof(asyncQuery4), "%s", asyncQuery);
					active[3]++;
				}
				case 5:
				{
					Format(asyncQuery5, sizeof(asyncQuery5), "%s", asyncQuery);
					active[4]++;
				}
				case 6:
				{
					Format(asyncQuery6, sizeof(asyncQuery6), "%s", asyncQuery);
					active[5]++;
				}
				case 7:
				{
					Format(asyncQuery7, sizeof(asyncQuery7), "%s", asyncQuery);
					active[6]++;
				}
				case 8:
				{
					Format(asyncQuery8, sizeof(asyncQuery8), "%s", asyncQuery);
					active[7]++;
				}
				case 9:
				{
					Format(asyncQuery9, sizeof(asyncQuery9), "%s", asyncQuery);
					active[8]++;
				}
				case 10:
				{
					Format(asyncQuery10, sizeof(asyncQuery10), "%s", asyncQuery);
					active[9]++;
				}
				case 11:
				{
					Format(asyncQuery11, sizeof(asyncQuery11), "%s", asyncQuery);
					active[10]++;
				}
				case 12:
				{
					Format(asyncQuery12, sizeof(asyncQuery12), "%s", asyncQuery);
					active[11]++;
				}
				case 13:
				{
					Format(asyncQuery13, sizeof(asyncQuery13), "%s", asyncQuery);
					active[12]++;
				}
				case 14:
				{
					Format(asyncQuery14, sizeof(asyncQuery14), "%s", asyncQuery);
					active[13]++;
				}
				default:
				{
					PrintToServer("%s:%d", "A major error has occured", i);
				}
			}
			
			
		}
		//PrintToServer("Query: %s", query);
	}
	if(queriesStored > maxclients) queriesStored = maxclients;
	if(queriesStored > 0) CreateTimer(0.1, Timer_executeQueries);
	return;
} 

public Action:Timer_executeQueries(Handle:timer)
{
	if(dbLocked > 0) {
		CreateTimer(0.10, Timer_executeQueries);
		PrintToServer("%s", "Thread is locked. Slowing down running of queries.");
		return; //if the db is locked wait another 0.1 seconds
	}
	if(dbc == INVALID_HANDLE)
	{
		//PrintToServer("%s", "Complete Database Failure. Locking database out.");
		PrintToServer("%s", "Complete Database Failure. Reconnecting.");
		//dbLocked = 2;//set to error code
		//queriesStored = 127;
		dbc = SQL_Connect("render", false, errorc, sizeof(errorc));
		
		return;
	}
	else{
		if(queriesStored < 1) return; //loop over
		dbLocked = 1;
		
		switch(queriesStored)
		{
			case 1:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery1, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 2:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery2, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 3:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery3, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 4:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery4, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 5:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery5, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 6:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery6, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 7:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery7, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 8:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery8, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 9:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery9, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 10:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery10, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 11:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery11, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 12:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery12, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
		    case 13:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery13, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			case 14:
			{
				if(alive[queriesStored-1] > 0 || active[queriesStored-1] > maxPlayers ) SQL_TQuery(dbc, queryCallback, asyncQuery14, queriesStored);
				else {
					queriesStored--; //decrement now that we know its executed
					dbLocked = 0; //unlock db after everything is done
				}
			}
			default:
			{
				PrintToServer("%s:%d", "A major error has occured in exec", queriesStored);
				return;
			}
		}
		if(queriesStored > 0 && queriesStored < maxPlayers) alive[queriesStored] = 0; //reset alive status
		else{PrintToServer("%s:%d", "A major error has occured in exec", queriesStored);}
		if(queriesStored > 0) CreateTimer(0.1, Timer_executeQueries); //run until all queries are complete
	}
	return;
}



